#include <bits/stdc++.h>
using namespace std;
using ll = long long;


bool itog(ll n, ll mid, vector<ll> t1, vector<ll> t2, ll m){
    ll result=0;
    for(int i=0; i<n; i++){
        if(mid<t1[i]){
            result+=0;
        }
        if(mid>=t1[i] && mid-t1[i]-t2[i]<0){
            result+=1;
        }
        if(mid-t1[i]-t2[i]>=0){
            if(mid-t1[i]-t2[i]>log2l(m)) return true;
            result+= powl(2ll, mid-t1[i]-t2[i]+1);
        }
    }
    return result>=m;
}


int main() {
    ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
    ll n, m;
    cin >> n >> m;
    vector<ll> t1(n);
    vector<ll> t2(n);
    for(int i=0; i<n; i++){
        cin >> t1[i];
    }
    for(int i=0; i<n; i++){
        cin >> t2[i];
    }
    ll lo=0, hi=1e9;
    while(lo+1<hi){
        ll mid=(lo+hi)/2;
        if(itog(n, mid, t1, t2, m)){
            hi=mid;
        }
        else{
            lo=mid;
        }
    }
    cout << hi;
    return 0;
}
